
Option Explicit
Dim strSize, strOutname, strArtname, numberfiles, progressstep, numberdone, progbar , listfiles
Main

Sub Main
Dim fs, strSourceStartFolder, WshShell
	ReDim listfiles(0)
	numberfiles=0
	Set fs = CreateObject("Scripting.FileSystemObject")
	'Get the source folder
	If WScript.Arguments.Named.Exists("source") Then
		strSourceStartFolder = WScript.Arguments.Named.Item("source")
	Else
		strSourceStartFolder = BrowseForFolder("SOURCE FOLDER (Or use the /source argument like " & vbCrLf & WScript.ScriptName & " /source:""C:\Some Folder"")")
	End If
	
	If WScript.Arguments.Named.Exists("size") Then
		strSize = WScript.Arguments.Named.Item("size")
	Else
		strSize = "150"
	End If
	
	If WScript.Arguments.Named.Exists("artname") Then
		strArtname = WScript.Arguments.Named.Item("artname")
	Else
		strArtname = "folder.jpg"
	End If

	If WScript.Arguments.Named.Exists("outputname") Then
		strOutname = WScript.Arguments.Named.Item("outputname")
	Else
		strOutname = "cover"
	End If
	
	If strSourceStartFolder = "" Then Exit Sub
	If Not fs.FolderExists(strSourceStartFolder) Then Exit Sub
		
	Set progbar = createobject("JSProgBr.Bar")
	progbar.Title = "Preparing ..." 
	progbar.Caption = "Preparing list of files to convert"
	progbar.Show True, True
		
	FindFileNumber strArtname, strSourceStartFolder
	
	progbar.Title = "Proceeding " & numberfiles & " album art(s)"
	progbar.Caption = "Processing"
	
	If numberfiles >=30 Then		
		progressstep=Int(numberfiles/30)
	Else 
		progressstep=1
	End If	
	Set WshShell = WScript.CreateObject("WScript.Shell")
	Dim FileName
	For Each FileName In listfiles
		If FileName<> "" Then
      progbar.Caption = "Proceeding " & FileName
			WshShell.Run "LFC """ & FileName & """ " & "/R" & strSize & "x" & strSize & " /F=FILE_BMP /NOUI",0 , True	
			WshShell.run "cmd /K " & "rename """ & Left(FileName, Len(FileName) - 4) & ".bmp"" """ & strOutname & ".bmp""" & " & exit",0,True		
			numberdone=numberdone+1
			If numberdone Mod progressstep = 0 Then	
				progbar.Advance
			End If
		End If
  Next
  Set WshShell = Nothing
	
	'Update the destination tree with files from the source tree
	'UpdateTree strSourceStartFolder
	
	progbar.hide
	set progbar = nothing
End Sub


Sub UpdateTree(strSourceStartFolder)
Dim fs, fil, fils, fol, fols, ofol, strRockboxFile, WshShell, strAlbumartFile, strTempFile
	progbar.Caption = "Proceeding " & strSourceStartFolder
	Set fs = CreateObject("Scripting.FileSystemObject")
	Set ofol = fs.GetFolder(strSourceStartFolder)
	'Check for cover.bmp file in each folder
	On Error Resume Next
	Err.Clear
	Set fils = ofol.Files
	If Err.Number <> 0 Then Exit Sub
	
	strRockboxFile = FindFile("cover.bmp", strSourceStartFolder)
	If strRockboxFile = "" Then	
		strAlbumartFile = FindFile("folder.jpg", strSourceStartFolder)	
		If strAlbumartFile <> "" Then
			Set WshShell = WScript.CreateObject("WScript.Shell")
			Return=WshShell.Run ("LFC """ & strSourceStartFolder & "\" & strArtname & """ " & "/R" & strSize & "x" & strSize & " /F=FILE_BMP /NOUI",0 , True)
			
			If Return=0 Then 		
				'Dim oShell
				'Set oShell = WScript.CreateObject ("WScript.shell")					
				'oShell.run "rename """ & strSourceStartFolder & "\folder.bmp"" """ & strOutname & ".bmp"""	
				WshShell.run "cmd /K " & "rename """ & strSourceStartFolder & "\folder.bmp"" """ & strOutname & ".bmp""" & " & exit",0,True
				Set WshShell = Nothing
				numberdone=numberdone+1
				If numberdone Mod progressstep = 0 Then
					WshShell.Popup "",, "My Popup Dialogue box"
					progbar.Advance
				End If
			End If
		End If
	End If
	'Check for any sub folders and recursively process them
	Set fols = ofol.SubFolders
	For each fol in fols
		If Lcase(fol.Name) <> "recycled" Then
			UpdateTree fol.Path
		End If
	Next
End Sub


Function FindFile(strFileName, strStartPath)
Dim fs, fil, fils, fol, fols, ofol, strFound
	Set fs = CreateObject("Scripting.FileSystemObject")
	Set ofol = fs.GetFolder(strStartPath)
	'Check each file in the folder
	'On Error Resume Next
	Err.Clear
	Set fils = ofol.Files
	If Err.Number = 0 Then 
		For Each fil In fils
			If Lcase(fil.Name) = Lcase(strFileName) Then
				'Return the path to the file
				FindFile = fil.Path
				Exit Function
			End If
		Next
	End If
	'Return an empty result if the file isn't found
	FindFile = ""
End Function

Sub Status(strMessage)
	If Lcase(Right(Wscript.FullName, 12)) = "\cscript.exe" Then
		Wscript.Echo strMessage
	End If
End Sub

Function BrowseForFolder(strPrompt)
'Uses the "Shell.Application" (only present in Win98 and newer)
'to bring up a file/folder selection window. Falls back to an
'ugly input box under Win95.
Const ssfDRIVES = 17 'My Computer
Const SFVVO_SHOWALLOBJECTS = 1
Const SFVVO_SHOWEXTENSIONS = 2 
	Dim sh, fol, fs, lngView, strPath
	Set sh = CreateObject("Shell.Application")
	If Instr(TypeName(sh), "Shell") = 0 Then
		BrowseForFolder = InputBox(strPrompt, "Select Folder", CreateObject("Scripting.FileSystemObject").GetParentFolderName(WScript.ScriptFullName))
		Exit Function
	End If
	Set fs = CreateObject("Scripting.FileSystemObject")
	lngView = SFVVO_SHOWALLOBJECTS Or SFVVO_SHOWEXTENSIONS
	strPath = ""
	Set fol = sh.BrowseForFolder(&0, strPrompt, lngView, ssfDRIVES)
	Err.Clear
	On Error Resume Next
	strPath = fol.ParentFolder.ParseName(fol.Title).Path
	'An error occurs if the user selects a drive instead of a folder
	If Err.Number <> 0 Then
		BrowseForFolder = Left(Right(fol.Title, 3), 2) & "\"
	Else
		BrowseForFolder = strPath
	End If
End Function

Function FindFileNumber(strFileName, strStartPath)
    Dim File, fs, strRockboxFile
    Dim Folder
    
    Set fs = CreateObject("Scripting.FileSystemObject")
		For Each File In fs.GetFolder(strStartPath).Files
    	If LCase(File.Name) = strFileName Then
    		strRockboxFile = FindFile(strOutname  &".bmp", strStartPath)
				If strRockboxFile = "" Then	
    	 		ReDim Preserve listfiles(numberfiles + 1)
       		listfiles(numberfiles)=File.Path
       		numberfiles = numberfiles + 1
      	End If
      	Exit For
    	End If
 		Next 'File

    For Each Folder In fs.GetFolder(strStartPath).SubFolders
       Call FindFileNumber(strFileName,Folder)
    Next 'Folder
End Function